#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

/* Usage: marksize filename */

/* This is a build tool used to mark the starting point of the squashfs image
 * appended to a "firmware" style kernel, for use by the firmware_init program
 * in initramfs.
 *
 * For a User Mode Linux executable, the ELF header is padded to 16 bytes, of
 * which the first 10 are currently used.  We grab the last four bytes of this
 * on the assumption that if they use more in future, they'll use the two at
 * the beginning first.
 *
 * For a bootable Linux kernel, the first 512 bytes are the old floppy boot
 * sector (arch/i386/bootsect.S) which was removed during the 2.5 series and
 * replaced with a stub bootsector that prints the warning message "Direct
 * booting from floppy is no longer supported, please use a boot loader
 * program instead."  Breaking this stub doesn't really have a major downside.
 *
 * You'd think there would be an easy way to convert a decimal into four binary
 * bytes in a shell script using SuSv3 command line tools, but if so I haven't
 * found it yet...
 */

int main(int argc, char *argv[])
{
  int fd,len;
  fd=open(argv[1],O_RDWR);
  len=lseek(fd,0,SEEK_END);
  lseek(fd,12,SEEK_SET);
  write(fd,&len,4);
  close(fd);
}
