#!/bin/sh

echo "=== Create temporary directory." &&
echo "Creating tmpdir..." &&
if [ -h tmpdir ]
then
  rm -rf tmpdir/*
else
  rm -rf tmpdir &&
  mkdir tmpdir
fi
if [ $? -ne 0 ]; then exit 1; fi

echo "=== Build squashfs" &&
tar xvzfC sources/system/squashfs2.2-r2.tar.gz tmpdir &&
gcc -s -Os -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -lz \
	tmpdir/squashfs2.2-r2/squashfs-tools/{mksquashfs.c,read_fs.c,sort.c} \
	-I tmpdir/squashfs2.2-r2/squashfs-tools -o tmpdir/mksquashfs &&
rm -rf tmpdir/squashfs2.2-r2

if [ $? -ne 0 ]; then exit 1; fi

echo "=== Create ext2 image for writeable UML workspace." &&
dd if=/dev/zero of=tmpdir/workspace.img bs=524288 count=1024 &&
dd if=/dev/zero of=tmpdir/swap.img bs=262144 count=1024 &&
sync &&
/sbin/mkswap tmpdir/swap.img &&
/sbin/mke2fs -F tmpdir/workspace.img &&
mkdir tmpdir/sub

if [ $? -ne 0 ]; then exit 1; fi
