#!/bin/sh

# Script run from the second invocation of UML.  Set up UML environment with
# /tools mounted from tools.img, and /tools/sources bind mounted under that.

export PATH=/sbin:/usr/sbin:/bin:/usr/bin
cd "$DIR"/tmpdir &&

# Mount workspace, and /tools and /sources in that.

mount -n -o loop -t ext2 workspace.img sub &&
mkdir sub/{tools,sources} &&
mount -n -o loop -t squashfs tools.img sub/tools &&
mount -n --bind ../sources sub/sources &&

# Enable swap
mkdir sub/sys &&
mount -t sysfs sub/sys sub/sys &&
mknod -m 700 sub/ubda b `sed 's/:.*//' sub/sys/block/ubda/dev` \
        `sed 's/.*://' sub/sys/block/ubda/dev` &&
swapon sub/ubda &&
umount sub/sys &&
rmdir sub/sys &&
rm sub/ubda

if [ $? -ne 0 ]; then exit 1; fi

rmdir sub/lost+found 2>/dev/null

# Run the next stage build script

chroot sub sources/scripts/2.2-firmware-build.sh

# Did the build complete?

if [ -f sub/build_complete ]
then
  rm -f build.sqf 2> /dev/null
  rm -f sub/build_complete &&
  umount sub/tools sub/sources &&
  mv sub/tmp/initramfs-busybox . &&
  ./mksquashfs sub build.sqf -info
fi
